#[derive(Debug, Copy, Clone, Default)]
pub enum Gradient {
    PurpleBlue,
    PinkOrange,
    CyanBlue,
    TealLime,
    PurplePink,
    #[default]
    Orange,
    Pink,
    PinkRed,
}
impl Gradient {
    pub fn class_from(&self) -> &'static str {
        match self {
            Gradient::PinkOrange => "from-pink-500",
            Gradient::CyanBlue => "from-cyan-500",
            Gradient::TealLime => "from-teal-300",
            Gradient::PurplePink => "from-purple-500",
            Gradient::PurpleBlue => "from-purple-600",
            Gradient::Orange => "from-orange-400",
            Gradient::Pink => "from-pink-400",
            Gradient::PinkRed => "from-pink-400",
        }
    }

    pub fn class_to(&self) -> &'static str {
        match self {
            Gradient::PinkOrange => "to-orange-400",
            Gradient::CyanBlue => "to-blue-500",
            Gradient::TealLime => "to-lime-300",
            Gradient::PurplePink => "to-pink-500",
            Gradient::PurpleBlue => "to-blue-500",
            Gradient::Orange => "to-orange-500",
            Gradient::Pink => "to-pink-500",
            Gradient::PinkRed => "to-red-500",
        }
    }

    pub fn class_text(&self) -> &'static str {
        match self {
            Gradient::PinkOrange => "text-rose-400",
            Gradient::CyanBlue => "text-cyan-500",
            Gradient::TealLime => "text-emerald-300",
            Gradient::PurplePink => "text-fuchsia-500",
            Gradient::PurpleBlue => "text-purple-600",
            Gradient::Orange => "text-orange-400",
            Gradient::Pink => "text-pink-400",
            Gradient::PinkRed => "text-pink-400",
        }
    }
}
